diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index a3e142cc9..22701c5b4 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -1,9 +1,8 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.piston.MovingPistonBlockEntity;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -14,20 +13,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.slf4j.Logger;
-
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Objects;
 
 public class BlockEntity implements ICarriable
 {
-    private static final Logger LOGGER = LogUtils.getLogger();
-
-    private static final Map<String, Class<? extends BlockEntity>> nameToClassMap = new HashMap<>();
-    private static final Map<Class<? extends BlockEntity>, String> classToNameMap = new HashMap<>();
     public @Nullable World worldObj; // Null when loading data from nbt and null when held by entity
     public @Nullable CarriedBlock carriedBlock;
     public int x;
@@ -39,78 +28,10 @@ public class BlockEntity implements ICarriable
     {
     }
 
-    private static void addMapping(Class<? extends BlockEntity> entityClass, String name)
-    {
-        if(nameToClassMap.containsKey(name))
-        {
-            throw new IllegalArgumentException("Duplicate id: " + name);
-        } else
-        {
-            nameToClassMap.put(name, entityClass);
-            classToNameMap.put(entityClass, name);
-        }
-    }
-
-    public void readFromNBT(CompoundTag nbttagcompound)
-    {
-        x = nbttagcompound.getInteger("x");
-        y = nbttagcompound.getInteger("y");
-        z = nbttagcompound.getInteger("z");
-    }
-
-    public void writeToNBT(CompoundTag nbttagcompound)
-    {
-        String name = classToNameMap.get(getClass());
-        if(name == null)
-        {
-            throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
-        } else
-        {
-            nbttagcompound.putString("id", name);
-            nbttagcompound.putInt("x", x);
-            nbttagcompound.putInt("y", y);
-            nbttagcompound.putInt("z", z);
-        }
-    }
-
     public void tick()
     {
     }
 
-    public static BlockEntity createAndLoadEntity(CompoundTag nbttagcompound)
-    {
-        BlockEntity blockEntity = null;
-        Class<? extends BlockEntity> entityClass = nameToClassMap.get(nbttagcompound.getString("id"));
-        try
-        {
-            if(entityClass != null)
-            {
-                blockEntity = entityClass.newInstance();
-            }
-        }
-        catch(Exception exception)
-        {
-            LOGGER.error("Exception when instancing class '{}'!", entityClass.getSimpleName(), exception);
-        }
-        if(blockEntity != null)
-        {
-            blockEntity.readFromNBT(nbttagcompound);
-        } else
-        {
-            LOGGER.warn("Skipping BlockEntity with id {}", nbttagcompound.getString("id"));
-        }
-        return blockEntity;
-    }
-
-    public static Class<? extends BlockEntity> getClassFromID(String id)
-    {
-        return nameToClassMap.get(id);
-    }
-
-    public int getMovedData()
-    {
-        return worldObj.getBlockMetadata(x, y, z);
-    }
 
     public void setChanged()
     {
@@ -125,17 +46,37 @@ public class BlockEntity implements ICarriable
         return null;
     }
 
-    public double getDistanceFrom(double d, double d1, double d2)
-    {
-        double d3 = ((double) x + 0.5D) - d;
-        double d4 = ((double) y + 0.5D) - d1;
-        double d5 = ((double) z + 0.5D) - d2;
-        return d3 * d3 + d4 * d4 + d5 * d5;
+    public int getBlockId() {
+        if (carriedBlock != null) {
+            return carriedBlock.blockId;
+        } else {
+            return worldObj.getBlockId(x, y, z);
+        }
+    }
+
+    public Block getBlock() {
+        if (carriedBlock != null) {
+            return carriedBlock.block();
+        } else {
+            return worldObj.getBlock(x, y, z);
+        }
+    }
+
+    public int getBlockMeta() {
+        if (carriedBlock != null) {
+            return carriedBlock.metadata;
+        } else {
+            return worldObj.getBlockMetadata(x, y, z);
+        }
     }
 
-    public Block getBlockType()
+
+    public double getDistanceFrom(double x, double y, double z)
     {
-        return Block.blocksList[worldObj.getBlockId(x, y, z)];
+        double dx = ((double) this.x + 0.5D) - x;
+        double dy = ((double) this.y + 0.5D) - y;
+        double dz = ((double) this.z + 0.5D) - z;
+        return dx * dx + dy * dy + dz * dz;
     }
 
     public boolean isInvalid()
@@ -153,24 +94,26 @@ public class BlockEntity implements ICarriable
         tileEntityInvalid = false;
     }
 
-    static 
+    public void readFromNBT(CompoundTag nbttagcompound)
     {
-        addMapping(FurnaceBlockEntity.class, "Furnace");
-        addMapping(ChestBlockEntity.class, "Chest");
-        addMapping(JukeboxBlockEntity.class, "RecordPlayer");
-        addMapping(DispenserBlockEntity.class, "Trap");
-        addMapping(SignBlockEntity.class, "Sign");
-        addMapping(MobSpawnerBlockEntity.class, "MobSpawner");
-        addMapping(NoteBlockEntity.class, "Music");
-        addMapping(MovingPistonBlockEntity.class, "Piston");
-        addMapping(BlastFurnaceBlockEntity.class, "BlastFurnace");
-        addMapping(SensorBlockEntity.class, "Sensor");
-        addMapping(TrommelBlockEntity.class, "Trommel");
-        addMapping(BasketBlockEntity.class, "Basket");
-        addMapping(FlagBlockEntity.class, "Flag");
-        addMapping(SeatBlockEntity.class, "Seat");
-        addMapping(FlowerJarBlockEntity.class, "FlowerJar");
-        addMapping(GoldMeshBlockEntity.class, "MeshGold");
+        x = nbttagcompound.getInteger("x");
+        y = nbttagcompound.getInteger("y");
+        z = nbttagcompound.getInteger("z");
+    }
+
+    public void writeToNBT(CompoundTag nbttagcompound)
+    {
+        String name = BlockEntityDispatcher.getIDFromClass(getClass());
+        if(name == null)
+        {
+            throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
+        } else
+        {
+            nbttagcompound.putString("id", name);
+            nbttagcompound.putInt("x", x);
+            nbttagcompound.putInt("y", y);
+            nbttagcompound.putInt("z", z);
+        }
     }
 
     @Override
@@ -190,7 +133,7 @@ public class BlockEntity implements ICarriable
 
         Block currentBlock = world.getBlock(x, y, z);
         if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
-        world.setBlockAndMetadataWithNotify(x, y, z, carriedBlock.block.id, carriedBlock.metadata);
+        world.setBlockAndMetadataWithNotify(x, y, z, carriedBlock.blockId, carriedBlock.metadata);
 
         worldObj = world;
         this.carriedBlock = null;
@@ -221,7 +164,7 @@ public class BlockEntity implements ICarriable
         if (world.isClientSide) return;
         dropContents(world, holderX, holderY, holderZ);
         assert carriedBlock != null;
-        carriedBlock.block.dropBlockWithCause(world, EnumDropCause.WORLD, holderX, holderY, holderZ, carriedBlock.metadata, this, null); // TODO this might be scuffed since the position won't have correlated to a real block
+        carriedBlock.block().dropBlockWithCause(world, EnumDropCause.WORLD, holderX, holderY, holderZ, carriedBlock.metadata, this, null); // TODO this might be scuffed since the position won't have correlated to a real block
     }
 
     @Override
@@ -247,73 +190,4 @@ public class BlockEntity implements ICarriable
         return new CarriedBlock(holder, currentBlock, currentMeta, this);
     }
 
-    public static class CarriedBlock implements ICarriable {
-        // Ignore warnings, nbt read process *should* guarantee these to be non-null
-        public @NotNull Block block;
-        public int metadata;
-        public @NotNull BlockEntity entity;
-        public @NotNull Entity holder;
-        public @NotNull World world;
-        public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @NotNull BlockEntity entity) {
-            this.holder = holder;
-            this.block = block;
-            this.metadata = metadata;
-            this.entity = entity;
-            this.world = holder.world;
-        }
-
-        protected CarriedBlock() {
-
-        }
-
-        @Override
-        public void heldTick(World world, Entity holder) {
-            entity.heldTick(world, holder);
-        }
-
-        @Override
-        public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-            return entity.tryPlace(world, holder, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-        }
-
-        @Override
-        public void drop(World world, Entity holder) {
-            entity.drop(world, holder);
-        }
-
-        @Override
-        public boolean canBeCarried(World world, Entity potentialHolder) {
-            return entity.canBeCarried(world, potentialHolder);
-        }
-
-        @Override
-        public ICarriable pickup(World world, Entity holder) {
-            return entity.pickup(world, holder);
-        }
-
-        @Override
-        public void writeToNBT(CompoundTag tag) {
-            CompoundTag entityTag = new CompoundTag();
-            entity.writeToNBT(entityTag);
-            tag.put("entity", entityTag);
-            tag.putInt("block", block.id);
-            tag.putShort("meta", (short) metadata);
-            tag.putString("type", "blockEntity");
-        }
-
-        @Override
-        public void readFromNBT(CompoundTag tag) {
-            entity = createAndLoadEntity(tag.getCompound("entity"));
-            entity.carriedBlock = this;
-            block = Objects.requireNonNull(Block.getBlock(tag.getInteger("block")));
-            metadata = tag.getShort("meta");
-        }
-
-        public static CarriedBlock createAndLoadCarriedBlock(@NotNull Entity holder, CompoundTag tag) {
-            CarriedBlock carriedBlock = new CarriedBlock();
-            carriedBlock.holder = holder;
-            carriedBlock.readFromNBT(tag);
-            return carriedBlock;
-        }
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java b/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java
new file mode 100644
index 000000000..953a78d42
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java
@@ -0,0 +1,83 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.piston.MovingPistonBlockEntity;
+import org.slf4j.Logger;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class BlockEntityDispatcher {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private static final Map<String, Class<? extends BlockEntity>> nameToClassMap = new HashMap<>();
+    private static final Map<Class<? extends BlockEntity>, String> classToNameMap = new HashMap<>();
+
+    public static void addMapping(Class<? extends BlockEntity> entityClass, String name)
+    {
+        if(nameToClassMap.containsKey(name))
+        {
+            throw new IllegalArgumentException("Duplicate id: " + name);
+        } else
+        {
+            nameToClassMap.put(name, entityClass);
+            classToNameMap.put(entityClass, name);
+        }
+    }
+
+    public static BlockEntity createAndLoadEntity(CompoundTag nbttagcompound)
+    {
+        BlockEntity blockEntity = null;
+        Class<? extends BlockEntity> entityClass = nameToClassMap.get(nbttagcompound.getString("id"));
+        try
+        {
+            if(entityClass != null)
+            {
+                blockEntity = entityClass.newInstance();
+            }
+        }
+        catch(Exception exception)
+        {
+            LOGGER.error("Exception when instancing class '{}'!", entityClass.getSimpleName(), exception);
+        }
+        if(blockEntity != null)
+        {
+            blockEntity.readFromNBT(nbttagcompound);
+        } else
+        {
+            LOGGER.warn("Skipping BlockEntity with id {}", nbttagcompound.getString("id"));
+        }
+        return blockEntity;
+    }
+
+    public static Class<? extends BlockEntity> getClassFromID(String id)
+    {
+        return nameToClassMap.get(id);
+    }
+
+    public static String getIDFromClass(Class<? extends BlockEntity> clazz)
+    {
+        return classToNameMap.get(clazz);
+    }
+
+    static
+    {
+        addMapping(FurnaceBlockEntity.class, "Furnace");
+        addMapping(ChestBlockEntity.class, "Chest");
+        addMapping(JukeboxBlockEntity.class, "RecordPlayer");
+        addMapping(DispenserBlockEntity.class, "Trap");
+        addMapping(SignBlockEntity.class, "Sign");
+        addMapping(MobSpawnerBlockEntity.class, "MobSpawner");
+        addMapping(NoteBlockEntity.class, "Music");
+        addMapping(MovingPistonBlockEntity.class, "Piston");
+        addMapping(BlastFurnaceBlockEntity.class, "BlastFurnace");
+        addMapping(SensorBlockEntity.class, "Sensor");
+        addMapping(TrommelBlockEntity.class, "Trommel");
+        addMapping(BasketBlockEntity.class, "Basket");
+        addMapping(FlagBlockEntity.class, "Flag");
+        addMapping(SeatBlockEntity.class, "Seat");
+        addMapping(FlowerJarBlockEntity.class, "FlowerJar");
+        addMapping(GoldMeshBlockEntity.class, "MeshGold");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
index a9b147df7..2d34a4b72 100644
--- a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
@@ -8,6 +8,7 @@ package net.minecraft.core.block.entity;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.ChestBlock;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
diff --git a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
index 63a328024..4dc9298a7 100644
--- a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
diff --git a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
index c94621a16..ed04eedf6 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.StackedFlowerBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
@@ -12,11 +13,13 @@ import net.minecraft.core.world.World;
 public class FlowerJarBlockEntity extends BlockEntity {
 
     public int flowerInPot;
+    public int flowerData;
 
     @Override
     public void readFromNBT(CompoundTag tag) {
         super.readFromNBT(tag);
         flowerInPot = tag.getInteger("PlantedId");
+        flowerData = Byte.toUnsignedInt(tag.getByteOrDefault("PlantedData", (byte) 0));
     }
 
     @Override
@@ -24,6 +27,7 @@ public class FlowerJarBlockEntity extends BlockEntity {
         super.writeToNBT(tag);
         if (flowerInPot > 0) {
             tag.putInt("PlantedId", flowerInPot);
+            tag.putByte("PlantedData", (byte) flowerData);
         }
     }
 
@@ -31,10 +35,14 @@ public class FlowerJarBlockEntity extends BlockEntity {
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
         if (flowerInPot > 0 && Block.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
-            flowerInPot = 0;
             if (!world.isClientSide) {
-                world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, 0));
+                if (Block.getBlock(flowerInPot) instanceof StackedFlowerBlock) {
+                    world.dropItem(x, y, z, new ItemStack(flowerInPot, StackedFlowerBlock.getStackCount(flowerData) + 1, 0));
+                } else {
+                    world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
+                }
             }
+            flowerInPot = 0;
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
index c88aeb46b..7f42cf2cd 100644
--- a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
@@ -11,6 +11,7 @@ import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.FurnaceBlock;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
@@ -311,7 +312,7 @@ public class FurnaceBlockEntity extends BlockEntity
         if (worldObj != null) {
             FurnaceBlock.updateFurnaceBlockState( forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
-            carriedBlock.block = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE : Blocks.FURNACE_STONE_IDLE;
+            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE.id : Blocks.FURNACE_STONE_IDLE.id;
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
index cbe8141d8..734eafd2b 100644
--- a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
@@ -54,7 +54,7 @@ public class NoteBlockEntity extends BlockEntity
         }
         Material material = world.getBlockMaterial(x, y - 1, z);
         byte noteIndex = 0;
-        if(material == Material.stone)
+        if(material.isStone())
         {
             noteIndex = 1;
         }
diff --git a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
index 7d7e15ea0..c2f64de27 100644
--- a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
@@ -1,7 +1,9 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 
@@ -10,18 +12,24 @@ public class SeatBlockEntity
     implements IVehicle {
     private Entity passenger;
 
-    public SeatBlockEntity() {
+    public Block seat;
+    public SeatBlockEntity(Block seat) {
         passenger = null;
+        this.seat = seat;
     }
 
     @Override
     public void tick() {
         if (passenger != null) {
-            worldObj.updateEntity(passenger);
+            if (carriedBlock != null) {
+                carriedBlock.world.updateEntity(passenger);
+            } else {
+                worldObj.updateEntity(passenger);
+            }
         }
 
         // TODO the server really needs a better way of telling the client that a tile entity no longer exists, but this works to fix the client thinking that the seat remains if its broken in multiplayer
-        if (worldObj.getBlock(x, y, z) != Blocks.SEAT){
+        if (worldObj != null && worldObj.getBlock(x, y, z) != seat) {
             ejectRider();
         }
     }
@@ -39,29 +47,56 @@ public class SeatBlockEntity
         this.passenger = null;
         entity.vehicle = null;
 
-        if (isSafe(this.x, this.y + 1, this.z)) {
-            entity.moveTo(this.x + 0.5, this.y + 1, this.z + 0.5, entity.yRot, entity.xRot);
-        } else if (isSafe(this.x - 1, this.y, this.z)) {
-            entity.moveTo(this.x - 0.5, this.y, this.z + 0.5, entity.yRot, entity.xRot);
-        } else if (isSafe(this.x + 1, this.y, this.z)) {
-            entity.moveTo(this.x + 1.5, this.y, this.z + 0.5, entity.yRot, entity.xRot);
-        } else if (isSafe(this.x, this.y, this.z - 1)) {
-            entity.moveTo(this.x + 0.5, this.y, this.z - 0.5, entity.yRot, entity.xRot);
-        } else if (isSafe(this.x, this.y, this.z + 1)) {
-            entity.moveTo(this.x + 0.5, this.y, this.z + 1.5, entity.yRot, entity.xRot);
+        double x, y, z;
+        if (carriedBlock != null) {
+            x = carriedBlock.holder.x;
+            y = carriedBlock.holder.y;
+            z = carriedBlock.holder.z;
         } else {
-            entity.moveTo(this.x + 0.5, this.y + 1, this.z + 0.5, entity.yRot, entity.xRot);
+            x = this.x;
+            y = this.y;
+            z = this.z;
+        }
+
+        if (isSafe(x, y + 1, z)) {
+            entity.moveTo(x + 0.5, y + 1, z + 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(x - 1, y, z)) {
+            entity.moveTo(x - 0.5, y, z + 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(x + 1, y, z)) {
+            entity.moveTo(x + 1.5, y, z + 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(x, y, z - 1)) {
+            entity.moveTo(x + 0.5, y, z - 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(x, y, z + 1)) {
+            entity.moveTo(x + 0.5, y, z + 1.5, entity.yRot, entity.xRot);
+        } else {
+            entity.moveTo(x + 0.5, y + 1, z + 0.5, entity.yRot, entity.xRot);
         }
 
         return entity;
     }
 
-    private boolean isSafe(int x, int y, int z) {
-        return !worldObj.isBlockNormalCube(x, y, z) && !worldObj.isBlockNormalCube(x, y + 1, z);
+    private boolean isSafe(double x, double y, double z) {
+        int _x = MathHelper.round(x);
+        int _y = MathHelper.round(y);
+        int _z = MathHelper.round(z);
+        if (carriedBlock != null) {
+            return !carriedBlock.world.isBlockNormalCube(_x, _y, _z) && !carriedBlock.world.isBlockNormalCube(_x, _y + 1, _z);
+        } else {
+            return !worldObj.isBlockNormalCube(_x, _y, _z) && !worldObj.isBlockNormalCube(_x, _y + 1, _z);
+        }
     }
     @Override
     public void positionRider() {
-        passenger.setPos(this.x + 0.5, this.y + 0.5 + passenger.getRidingHeight(), z + 0.5);
+        if (carriedBlock != null) {
+            passenger.setPos(carriedBlock.holder.x, carriedBlock.holder.y + passenger.getRidingHeight(), carriedBlock.holder.z);
+        } else {
+            passenger.setPos(this.x + 0.5, this.y + 0.5 + passenger.getRidingHeight(), z + 0.5);
+        }
+    }
+
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        ejectRider();
     }
 
     @Override
@@ -76,7 +111,11 @@ public class SeatBlockEntity
 
     @Override
     public void moveExitingEntity(Entity entity) {
-        entity.moveTo(this.x, this.y + 2, this.z, entity.yRot, entity.xRot);
+        if (carriedBlock != null) {
+            entity.moveTo(carriedBlock.holder.x, carriedBlock.holder.y + 2, carriedBlock.holder.z, entity.yRot, entity.xRot);
+        } else {
+            entity.moveTo(this.x, this.y + 2, this.z, entity.yRot, entity.xRot);
+        }
     }
 
     @Override
@@ -89,4 +128,8 @@ public class SeatBlockEntity
         return 0;
     }
 
+    @Override
+    public void heldTick(World world, Entity holder) {
+        tick();
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index ad118d63f..b4b337360 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.ChestBlock;
 import net.minecraft.core.block.TrommelBlock;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
@@ -186,7 +187,7 @@ public class TrommelBlockEntity extends BlockEntity
             			if (worldObj != null) {
                             TrommelBlock.updateTrommelBlockState(true, worldObj, x, y, z);
                         } else if (carriedBlock != null) {
-                            carriedBlock.block = Blocks.TROMMEL_ACTIVE;
+                            carriedBlock.blockId = Blocks.TROMMEL_ACTIVE.id;
                         }
                         flag1 = true;
                     }
@@ -234,7 +235,7 @@ public class TrommelBlockEntity extends BlockEntity
                 if (worldObj != null) {
                     TrommelBlock.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
                 } else if (carriedBlock != null) {
-                    carriedBlock.block = burnTime > 0 ? Blocks.TROMMEL_ACTIVE : Blocks.TROMMEL_IDLE;
+                    carriedBlock.blockId = burnTime > 0 ? Blocks.TROMMEL_ACTIVE.id : Blocks.TROMMEL_IDLE.id;
                 }
             }
         }
@@ -344,7 +345,7 @@ public class TrommelBlockEntity extends BlockEntity
                 slimeMob.moveTo(x + (double)f, y + 1D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
                 worldObj.entityJoinedWorld(slimeMob);
             } else if (carriedBlock != null) {
-                slimeMob.moveTo(carriedBlock.holder.x + (double)f, carriedBlock.holder.y + 1D, carriedBlock.holder.z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                slimeMob.moveTo(carriedBlock.holder.x + (double)f, carriedBlock.holder.y + carriedBlock.holder.heightOffset, carriedBlock.holder.z + (double)f1, random.nextFloat() * 360F, 0.0F);
                 carriedBlock.world.entityJoinedWorld(slimeMob);
             }
         }
diff --git a/src/main/java/net/minecraft/core/block/material/Material.java b/src/main/java/net/minecraft/core/block/material/Material.java
index 38333208f..e393e9cda 100644
--- a/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/src/main/java/net/minecraft/core/block/material/Material.java
@@ -16,6 +16,7 @@ public class Material
     private boolean notSolidBlocking;
     public final MaterialColor color;
     private boolean alwaysDestroyable;
+    private boolean isStone;
     private int pushReaction = PISTON_PUSHABLE;
     private int lightningConductivity = LIGHTNING_NEUTRAL;
 
@@ -45,6 +46,13 @@ public class Material
         return true;
     }
 
+    public Material setAsStone() {
+        isStone = true;
+        return this;
+    }
+
+    public boolean isStone() { return isStone; }
+
     public Material notSolidBlocking()
     {
         notSolidBlocking = true;
@@ -126,14 +134,14 @@ public class Material
     public static final Material dirt = new Material(MaterialColor.dirt);
     public static final Material wood = new Material(MaterialColor.wood).flammable();
 
-    public static final Material stone = new Material(MaterialColor.stone).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material basalt = new Material(MaterialColor.basalt).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material limestone = new Material(MaterialColor.limestone).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material granite = new Material(MaterialColor.granite).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material permafrost = new Material(MaterialColor.permafrost).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material marble = new Material(MaterialColor.marble).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material slate = new Material(MaterialColor.slate).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
-    public static final Material netherrack = new Material(MaterialColor.netherrack).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material stone = new Material(MaterialColor.stone).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material basalt = new Material(MaterialColor.basalt).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material limestone = new Material(MaterialColor.limestone).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material granite = new Material(MaterialColor.granite).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material permafrost = new Material(MaterialColor.permafrost).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material marble = new Material(MaterialColor.marble).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material slate = new Material(MaterialColor.slate).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
+    public static final Material netherrack = new Material(MaterialColor.netherrack).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
 
     public static final Material metal = new Material(MaterialColor.metal).setConductivity(LIGHTNING_STRONG_CONDUCTOR).notAlwaysDestroyable();
     public static final Material water = new LiquidMaterial(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
